// Skeleton implementation of problem 2 of Lab. 3
#include <stdio.h>
#include <stdlib.h>

// Constants used to determine the nature of the polygon

// for EDGES
// all edges equal
#define E_ALL_EQ (1)
// edges pairwise equal
#define E_PAIR_EQ (1 << 1)

// for ANGLES
// all angles equal
#define A_ALL_EQ (1 << 2)
// angles pairwise equal
#define A_PAIR_EQ (1 << 3)
// adjacent angles equal
#define A_ADJ_EQ (1 << 4)
// two adjacent angles are 90 degrees
#define A_ADJ_90 (1 << 5)
// two adjacent angles sum up to 180 degrees
#define A_ADJ_180 (1 << 6)
// one interior angle greater than 180 degress
#define A_GT_180 (1 << 7)

#define SQUARE (E_ALL_EQ | E_PAIR_EQ | A_ALL_EQ | A_PAIR_EQ | A_ADJ_EQ | A_ADJ_90 | A_ADJ_180)
#define RECTANGLE (E_PAIR_EQ | A_ALL_EQ | A_PAIR_EQ | A_ADJ_EQ | A_ADJ_90 | A_ADJ_180)
#define DIAMOND (E_ALL_EQ | E_PAIR_EQ | A_PAIR_EQ)
#define PARALELOGRAM (E_PAIR_EQ | A_PAIR_EQ | A_OP_180)
#define TRAPEZE (A_ADJ_180)
#define TRAPEZE_RECT (A_ADJ_180 | A_ADJ_90)
#define TRAPEZE_ISOS (A_ADJ_180 | A_ADJ_EQ)
#define CONCAVE (A_GT_180)
/***********************************************************
* FUNCTION NAME: doEdges
*
* DESCRIPTION:  determines useful info on the relationships netwen the edges
*               of the 4-edge polygon whose vertices are given as args, i.e.
*               whether they are all equal or pairwise equal
*
* ARGUMENT LIST:
* Argument        Type   IO      Description
* ------------- -------- -- --------------------------------
* double        x[4]     I  x coordinates of polygon vertices
* double        y[4]     I  y coordinates of polygon vertices
* RETURN VALUE: int       nature of polygon, formed using the
*                         constants starting with E_ (see defines)
*
* CHANGES: -
*************************************************************/
int doEdges(const double x[4], const double y[4])
{
    int nature = 0; // return value
    double lengths[4];
    // TODO: calculate the lengths of polygon edges
    // check if lengths are pairwise equal
    if (lengths[0] == lengths[2] && lengths[1] == lengths[3])
    {
        nature |= E_PAIR_EQ; // set edges pairwise equal
        if (lengths[0] == lengths[1])
            nature |= E_ALL_EQ; // set edges pairwise equal
    }
    return nature;
}
/***********************************************************
* FUNCTION NAME: doAngles
*
* DESCRIPTION:  determines useful info on the relationships netwen the angles
*               of the 4-edge polygon whose vertices are given as args, i.e.
*               whether they are all equal or pairwise equal
*
* ARGUMENT LIST:
* Argument        Type   IO      Description
* ------------- -------- -- --------------------------------
* double        x[4]     I  x coordinates of polygon vertices
* double        y[4]     I  y coordinates of polygon vertices
* RETURN VALUE: int       nature of polygon, formed using the
*                         constants starting with A_ (see defines)
*
* CHANGES: -
*************************************************************/
int doAngles(const double x[4], const double y[4])
{
    int nature = 0; // return value
    double angles[4];
    // TODO calculate angles
    // TODO set return value
    return nature;
}

int main()
{
    double x[4], y[4];
    int nature = 0;

    // read the coordinate values
    for (int i = 0; i < sizeof(x)/sizeof(x[0]); i++)
    {
        printf("x[%d]", i);
        if (1 != scanf("%lf", &x[i]))
        {
            printf("Bad value for x coordinate\n. Restart program, please\n");
            return 1;
        }
        printf("y[%d]", i);
        if (1 != scanf("%lf", &y[i]))
        {
            printf("Bad value for y coordinate\n. Restart program, please\n");
            return 1;
        }
    }
    // Compute lengths of edges and determine useful relationships for edges
    nature |= doEdges(x, y);
    // Compute values of interior angles and determine useful relationships for interior angles
    nature |= doAngles(x, y);

    printf("The given quadrilateral is a ");
    switch(nature)
    {
        case SQUARE:
            printf("square\n");
            break;
        // TODO rest of classification
        default:
            printf("irregular polygon\n");

    }
    return 0;
}
